%define _dfb_build_config	x@BUILD_CONFIG@

Name:		%{_stm_pkg_prefix}-target-directfb14@BUILD_CONFIG@
Summary:	Hardware graphics acceleration library
Group:		DirectFB/Libraries
%define _suffix		1.4
%define _shortversion	%{_suffix}.3
Version:	%{_shortversion}.STM2010.06.14
Release:	1
License:	LGPL
# created by:
# git archive --format=tar --prefix=DirectFB-1.4.3.STM2010.06.14/ DIRECTFB_1_4_3_STM2010.06.14 | bzip2 --best > DirectFB-1.4.3.STM2010.06.14.tar.bz2
Source0:	DirectFB-%{version}.tar.bz2
Patch0:		DirectFB-1.4.3.STM2009.12.11-autoconf259.patch

URL:		http://www.directfb.org
Buildroot:	%{_tmppath}/%{name}-%{_stm_target_arch}-root
Prefix:		%{_stm_cross_target_dir}

%if_target_cpu sh
BuildRequires:	%{_stm_pkg_prefix}-%{_stm_target_arch}-stmfb-headers >= 3.1_stm23_0030
%define _dfb_gfxdrivers stgfx
%else
%define _dfb_gfxdrivers none
%endif
%if "%{_dfb_build_config}" == "x-multi"
BuildRequires: %{_stm_pkg_prefix}-%{_stm_target_arch}-linux-fusion-headers >= 8.1.1
%define _dfb_multiapp --enable-multi
%else
%define _dfb_multiapp --disable-multi
%endif

%define _pkgname	%{_stm_pkg_prefix}-%{_stm_target_arch}-directfb14
%define _fullname	directfb-%{_suffix}-403
%define _docdir		%{_stm_cross_target_dir}%{_stm_target_doc_dir}


#
#  SRPM Package
#
%description
The source package for directfb.

#
#  RPMS
#
%package -n %{_pkgname}@BUILD_CONFIG@
Summary:	Hardware graphics acceleration library
Group:		DirectFB/Libraries
Provides:	%{_pkgname} = %{version}-%{release}
%if "%{_dfb_build_config}" == "x-multi"
Provides:	%{_pkgname}-multi = %{version}-%{release}
Conflicts:	%{_pkgname}-single
%else
Provides:	%{_pkgname}-single = %{version}-%{release}
Conflicts:	%{_pkgname}-multi
%endif
Obsoletes:	%{_stm_pkg_prefix}-%{_stm_target_arch}-directfb13
Obsoletes:	%{_stm_pkg_prefix}-%{_stm_target_arch}-directfb13-single
Obsoletes:	%{_stm_pkg_prefix}-%{_stm_target_arch}-directfb13-multi
%description -n %{_pkgname}@BUILD_CONFIG@
DirectFB is a thin library that provides developers with hardware graphics
acceleration, input device handling and abstraction, an integrated windowing
system with support for translucent windows and multiple display layers on top
of the Linux frame buffer device. It is a complete hardware abstraction layer
with software fallbacks for every graphics operation that is not supported by
the underlying hardware.
%if "%{_dfb_build_config}" == "x-multi"
This version has been built with the Multi Application Core.
%else
This version has been built with the Single Application Core.
%endif

%package -n %{_pkgname}@BUILD_CONFIG@-dev
Summary:	Hardware graphics acceleration library
Group:		DirectFB/Development
AutoReq:	no
Provides:	%{_pkgname}-dev = %{version}-%{release}
%if "%{_dfb_build_config}" == "x-multi"
Requires:	%{_pkgname}-multi = %{version}-%{release}
Provides:	%{_pkgname}-multi-dev = %{version}-%{release}
%else
Requires:	%{_pkgname}-single = %{version}-%{release}
Provides:	%{_pkgname}-single-dev = %{version}-%{release}
%endif
Obsoletes:	%{_stm_pkg_prefix}-%{_stm_target_arch}-directfb13-dev
Obsoletes:	%{_stm_pkg_prefix}-%{_stm_target_arch}-directfb13-single-dev
Obsoletes:	%{_stm_pkg_prefix}-%{_stm_target_arch}-directfb13-multi-dev
%description -n %{_pkgname}@BUILD_CONFIG@-dev
DirectFB header files needed for building DirectFB applications.


#
# PREP
#
%prep
%target_setup
%setup -q -n DirectFB-%{version}
%patch0 -p1

%target_autoreconf


#
# BUILD
#
%build
%target_setup
# the st231 compiler emits a warning when it encounters multiple -O statements,
# which makes auto* assume that some of its tests failed. Strip out existing -O
# and add -O3
_stripped_flags=
for _this_flag in $CFLAGS ; do
  _stripped_flags="${_stripped_flags} `echo $_this_flag | sed -e 's,-O.,,'`"
done
export CFLAGS="${_stripped_flags} -O3"
export LIBPNG_CONFIG=%{_stm_cross_bin_dir}/%{_stm_target_toolprefix}libpng-config
%target_configure \
	--enable-static \
	\
	--disable-sdl \
	\
	--with-gfxdrivers=%{_dfb_gfxdrivers} \
	\
	%{_dfb_multiapp} \
	\
	--program-suffix=-%{_suffix}
%pmake


#
# INSTALL
#
%install
%target_setup
mkdir -p %{buildroot}%{_stm_cross_bin_dir}
cd objdir
%make install DESTDIR=%{buildroot}%{_stm_cross_target_dir}

# Process target .pc files so they are useful in a cross environment
for f in %{buildroot}%{_stm_cross_target_dir}%{_stm_target_pkgconfig_dir}/*.pc ; do
  sed -i '/^prefix=/!s,%{_stm_target_prefix},${prefix},' $f
done

# build directfb-config for host environment
# we assume that _stm_target_lib_dir is in the default search path of both the cross
# and target dynamic linkers, to suppres spurious -L/usr/lib in *.la files
sed -e "s,libs=-L%{_stm_target_lib_dir},libs=,g" \
    -e "s,%{_stm_target_prefix},%{_stm_cross_target_dir}%{_stm_target_prefix},g" \
    < %{buildroot}%{_stm_cross_target_dir}%{_stm_target_bin_dir}/directfb-config-%{_suffix} \
    > %{buildroot}%{_stm_cross_bin_dir}/%{_stm_target_toolprefix}directfb-config-%{_suffix}
chmod +x %{buildroot}%{_stm_cross_bin_dir}/%{_stm_target_toolprefix}directfb-config-%{_suffix}

%target_install_fixup

# move pkg config files, so both versions of DirectFB can be installed
mkdir -p %{buildroot}%{_stm_cross_target_dir}%{_stm_target_pkgconfig_dir}/libdirectfb-%{_suffix}
mv %{buildroot}%{_stm_cross_target_dir}%{_stm_target_pkgconfig_dir}/*.pc \
    %{buildroot}%{_stm_cross_target_dir}%{_stm_target_pkgconfig_dir}/libdirectfb-%{_suffix}/

cd ..
cp COPYING LICENSE


#
# CLEAN
#
%clean
rm -rf %{buildroot}


#
# FILES
#
%files -n %{_pkgname}@BUILD_CONFIG@
%defattr(-,root,root)
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/lib*.so.*
%dir %{_stm_cross_target_dir}%{_stm_target_lib_dir}/%{_fullname}
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/%{_fullname}/*/lib*.so
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/%{_fullname}/interfaces/*/lib*.so
%dir %{_stm_cross_target_dir}%{_stm_target_data_dir}/directfb-%{_shortversion}
%{_stm_cross_target_dir}%{_stm_target_data_dir}/directfb-%{_shortversion}/cursor.dat
%{_stm_cross_target_dir}%{_stm_target_data_dir}/man/man5/directfbrc*5*
%doc LICENSE

%files -n %{_pkgname}@BUILD_CONFIG@-dev
%defattr(-,root,root)
%{_stm_cross_target_dir}%{_stm_target_bin_dir}/*
%{_stm_cross_target_dir}%{_stm_target_include_dir}/directfb-%{_shortversion}
%{_stm_cross_target_dir}%{_stm_target_include_dir}/directfb-%{_shortversion}-internal
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/lib*.so
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/lib*.a
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/lib*.la
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/%{_fullname}/*/lib*.a
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/%{_fullname}/*/lib*.la
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/%{_fullname}/*/lib*.o
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/%{_fullname}/interfaces/*/lib*.a
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/%{_fullname}/interfaces/*/lib*.la
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/%{_fullname}/interfaces/*/lib*.o
%dir %{_stm_cross_target_dir}%{_stm_target_pkgconfig_dir}/libdirectfb-%{_suffix}
%{_stm_cross_target_dir}%{_stm_target_pkgconfig_dir}/libdirectfb-%{_suffix}/*.pc
%{_stm_cross_target_dir}%{_stm_target_data_dir}/man/man1/dfbg*1*
%{_stm_cross_target_dir}%{_stm_target_data_dir}/man/man1/directfb-csource*1*
%{_stm_cross_bin_dir}/*
%doc AUTHORS LICENSE README


%changelog
* Mon Jun 14 2010 André Draszik <andre.draszik@st.com> 1.4.3.STM2010.06.14-1
- [Update: 1.4.3.STM2010.06.14] new release
- [Bugzilla: 9332] support 2 buffer formats in stgfx2
- [Bugzilla: 9333] better support for sti7106 and sti5206

* Sun Jun 06 2010 André Draszik <andre.draszik@st.com> 1.4.3.STM2010.06.06-1
- [Update: 1.4.3.STM2010.06.06] new release
- [Bugzilla: 8373] fix an eek
- [Bugzilla: 9253] add DSPF_YV16 pixelformat to DirectFB
- [Bugzilla: 9253] implement YV12 and YV16 acceleration in stgfx2
- jpeg: use YV16 to accelerate decoding of previously unsupported JPEGs

* Sat Jun 05 2010 André Draszik <andre.draszik@st.com> 1.4.3.STM2010.06.05-2
- [Update: 1.4.3.STM2010.06.05] new release
- jpeg: refactoring, cleanup, optimisations
- [Bugzilla: 9252] decimated raw libjpeg decode is incorrectly implemented
- jpeg: more preparations to use upcoming DSPF_YV16 pixelformat for raw
  decoding of 4:2:2 JPEGs
- jpeg: be more thorough when determining if raw decode is possible
- jpeg: Valgrind can't check stack variables, so we optionally allocate from
  the heap
- jpeg: speedup by disabling libjpeg's fancy upsampling and block smoothing

* Sat Jun 05 2010 André Draszik <andre.draszik@st.com> 1.4.3.STM2010.06.05-1
- [Update: 1.4.3.STM2010.06.05] new release
- merge in latest updates from DirectFB/master branch
- some debug mode assertions fixes
- jpeg: optimised setup for iDCT downscale for libjpeg version < 7
- jpeg: fix libjpeg >= v7 usage
- Fix for showing unitialized buffer and superfluous clear at startup
- fusion/lock: fix single app memory corruption
- Fixed wrong conversion from A8 to RGBA5551
- gfx: added LUT8 to LUT8 dest ckey blit fallback 'generic' routine
- RGB24 little endian software fallback fix
- pixelformat: Added DSPF_A1_LSB

* Wed Apr 14 2010 André Draszik <andre.draszik@st.com> 1.4.3.STM2010.04.14-1
- [Update: 1.4.3.STM2010.04.14] new release
- [Spec] remove some duplicates from %%files section
- [Spec] on sh4, BuildDepend on stmfb >= 0030
- merge in latest updates from DirectFB/master branch -> this release is not
  ABI compatible with previous releases
- [Bugzilla: 6974] fix off-by-one bug in IDirectFBFont_GetStringBreak()
- input: handle button devices with just up/down keys as keyboards, too
- [Bugzilla: 8373] fix subpixel blits vertical start position
- stgfx/stgfx2: only build if stmfb.h is installed
- stgfx2:
  + huge (!) internal state cleanup, resulting in up to 10-20% less CPU usage
    on drawing operations!
  + use (video range) YCbCr 601 -> RGB matrix when converting YCbCr->RGB (again)
  + [Bugzilla: 8256] XOR doesn't work as expected
  + [Bugzilla: 8406] handle YCbCr422R fast blits gracefully
  + [Bugzilla: 8366] desaturation of YCbCr surfaces
  + [Bugzilla: 8517] max. downscale is 1/63.99 not 1/31.99
  + [Bugzilla: 8682] enhanced support for STi7108

* Fri Feb 05 2010 André Draszik <andre.draszik@st.com> 1.4.3.STM2010.02.08-1
- [Bugzilla: 8193] do necessary changes (pollvsync_after)
- [Bugzilla: 7360, Bugzilla: 8077] subpixel vertical filter setup has been
  greatly simplified and corrected

* Fri Feb 05 2010 André Draszik <andre.draszik@st.com> 1.4.3.STM2010.02.05-1
- stgfx stgfx2: fix shutdown when not running in stmfbdev system
- linux_input: fix compilation if stmfbdev is disabled

* Sun Jan 31 2010 André Draszik <andre.draszik@st.com> 1.4.3.STM2010.01.31-1
- merge in latest updates from DirectFB/master branch
- stmfbdev: address compiler warnings in non debug builds
- stmfbdev: fix crash in shutdown
- stmfbdev: optimize ioctl handling
- stmfbdev: don't instanciate screens, layers & surface pools anymore
- stgfx/stgfx2: move instanciation of the above here, this gets us rid of more of DirectFB's startup warnings

* Fri Jan 29 2010 André Draszik <andre.draszik@st.com> 1.4.3.STM2010.01.29-1
- [Bugzilla: 7995] new system: 'stmfbdev' for many new features reg. screen control
- stgfx2:
  + some fixes for blit and fill if destination is YUV
  + WA for https://bugzilla.stlinux.com/show_bug.cgi?id=7084
  + update alignment restrictions for STi7108
  + stgfx surface pools: prevent confusing startup message
- stgfx:
  + update alignment restrictions for STi7108
  + stgfx surface pools: prevent confusing startup message
- misc:
  + dfbscreen: little fixes
  + generic: LUT8 is not a YUV format
  + screen: NTSC and PAL60 standards are defined as 59.94Hz not 60Hz
  + IDirectFBScreen: add IDirectFBScreen::GetVSyncCount()
  + directfb.h: add a DVO 656 'connector'
  + dfblayer: allow to set layer position and size using command line
  + dfbinspector: add DSPF_AVYU and DSPF_VYU pixelformats
- [Delete patch: DirectFB-1.4.3.STM2009.12.11-CLUT8_fix.patch] integrated upstream

* Fri Jan 29 2010 André Draszik <andre.draszik@st.com> 1.4.3.STM2009.12.11-4
- [Add patch: DirectFB-1.4.3.STM2009.12.11-CLUT8_fix.patch] fix CLUT8 issue in
  software renderer

* Mon Jan 11 2010 André Draszik <andre.draszik@st.com> 1.4.3.STM2009.12.11-3
- [Spec] unify multi app and single app spec files

* Wed Dec 16 2009 André Draszik <andre.draszik@st.com> 1.4.3.STM2009.12.11-2
- [Add patch: DirectFB-1.4.3.STM2009.12.11-autoconf259.patch] so as to enable
  successful build on arm with old autotools in STLinux-2.3

* Fri Dec 11 2009 André Draszik <andre.draszik@st.com> 1.4.3.STM2009.12.11-1
- [update: 2009-12.11] update to DirectFB 1.4.3
- misc: use pkgconfig to detect X11
- misc: surface: replace GetFramebufferOffset() with GetPhysicalAddress()
- stgfx2: pick up all updates from 1.0.1 branch
- stgfx2: release surface pools on shutdown
- [Bugzilla: 7776] stgfx2: cleanup draw/blitting wrt flags
- stgfx: release surface pools on shutdown
- [Bugzilla: 7570] jpeg: implement decimated decode for software JPEG decoder
- [Bugzilla: 7636] jpeg: implement raw libjpeg decode for possible HW acceleration (using stgfx2)

* Fri Aug 21 2009 André Draszik <andre.draszik@st.com> 1.4.1.STM2009.08.21-1
- [update: 2009-08-21]
  allow source widths and heights < 1.0 (but > 0) in BatchStretchBlit()

* Tue Aug 18 2009 André Draszik <andre.draszik@st.com> 1.4.1.STM2009.08.18-1
- [update: 2009-08-18]

* Tue Jul 29 2009 André Draszik <andre.draszik@st.com> 1
- [update: 1.4.1] new upstream version with all the STM patches
