#[stm-multicom]
#'BUILD_DIR=multicom-3.1.1
#'EXCLUDE_ALL="*~ *.orig *.rej"
#
#[patch modprobe]
#'INCLUDE_ONLY=modprobe.conf
#
#[end]
Summary:	Inter-processor communication software for multi-media applications
Name:		%{_stm_pkg_prefix}-multicom
Version:	3.2.4rc3
Release:	1
URL:		http://www.stlinux.com
License:	Proprietory
Group:		Development/System
Buildroot:	%{_tmppath}/%{name}-%{version}-root
Prefix:         %{_stm_install_prefix}
AutoReqProv:    no
Epoch:          1

Source:         RELEASE_MULTICOM_R3.2.4.rc3.tar.gz
Patch0:         multicom-3.2.1_b1-stlinux23_make.patch
Patch1:         multicom-3.2.1_b3_gpl_build.patch
Patch2:		multicom-3.2.4.rc3-fix_linux_user_build.patch
Patch11:        modprobe.patch

%description
Multicom combines thress distinct inter-processor communication 
technologies, MME, RPC and EMBX. MME is a communications API 
specifically designed to control media transformations. RPC is a 
Remote Procedure Call machanism that provides a means to communicate
between processors using normal function calls. EMBX is a low-level
communications API used by both MME and RPC to communicate with other 
processors. EMBX can also be used directly by applications with 
unusual requirements.

%ifarch noarch

%define _pkgname %{_stm_pkg_prefix}-host-multicom-source

%package -n %{_pkgname}
Summary           : Inter-processor communication software for multi-media applications
Group             : Development/System
Requires          : %{_stm_pkg_prefix}-host-filesystem
##Nosource: 0
AutoReqProv: no

%description -n %{_pkgname}
Source code for STMicroelectronics' Multicom product. Multicom combines 
thress distinct inter-processor communication technologies, MME, RPC 
and EMBX. MME is a communications API specifically designed to control 
media transformations. RPC is a Remote Procedure Call machanism that 
provides a means to communicate between processors using normal function
calls. EMBX is a low-level communications API used by both MME and RPC 
to communicate with other processors. EMBX can also be used directly by 
applications with unusual requirements.

%else

%define _pkgname %{_stm_pkg_prefix}-%{_stm_target_arch}-multicom

%package -n %{_pkgname}
Summary           : Inter-processor communication software for multi-media applications
Group             : Development/System
Requires          : %{_stm_pkg_prefix}-%{_stm_target_arch}-filesystem
AutoReqProv: no 

%description -n %{_pkgname}
User mode shared libraries for STMicroelectronics' Multicom product. 

%package -n %{_pkgname}-devel
Summary           : Inter-processor communication software for multi-media applications
Group             : Development/System
Requires          : %{_stm_pkg_prefix}-%{_stm_target_arch}-filesystem
AutoReqProv: no

%description -n %{_pkgname}-devel
User mode development headers for STMicroelectronics' Multicom product. 

%endif

%prep

%setup -qn RELEASE_MULTICOM_R3.2.4.rc3
chmod -R ug+rwX .
#%patch0 -p1 -b .orig-stlinux23_make
%patch1 -p1 -b .orig-gpl_build
%patch2 -p1 -b .orig-fix_linux_user_build

if [ "${DONT_INCLUDE_MANAGED_PATCHES}" != "yes" ]; then echo Including managed patches;
%patch11 -p1
fi;

# the execute permissions were stripped off too many files
for i in \
	src/embx/tests/transport/harness/ramfs/etc/rc.sysinit \
	src/embx/tests/transport/harness/ramfs/sbin/insmod \
	src/mme/test/harness/ramfs/etc/rc.sysinit \
	src/mme/test/harness/ramfs/sbin/insmod \
	src/rpc/test/harness/ramfs/etc/rc.sysinit \
	src/rpc/test/harness/ramfs/sbin/insmod
do
	chmod a+x $i
done

# destroy the target libraries (since if we patched the source then they become obsolete)
rm -rf lib

%build
%target_setup

## Tools should always be setup on the path before a build
## what we should do is package the st200 toolset into a rpm
## and then say the build requires that rpm
# explicitly set ST200ROOT and include it in the path
#ST200ROOT=/opt/STM/ST200R%{_st200ver}
#PATH=$ST200ROOT/bin:$PATH
#export ST200ROOT PATH

%ifarch noarch

# tidy up original files created during the patching
#find . -name "*.orig-*" | xargs rm -f

# forcibly enable the OS21 builds - this ensures that we can only rebuild
# this RPM if the embedded toolsets are on the path
make install ENABLE_ST40_LINUX=1 DISABLE_ST40_OS21=1 ENABLE_ST220_OS21=1 ENABLE_ST231_OS21=1

# get rid of the intermediate objects
# HACK HACK HACK - the clean rule in beta3 deletes all the object files as part of make clean...
mv lib lib.preserve
make clean
mv lib.preserve lib

%else

# build only the usermode libraries
make install ENABLE_ST40_LINUX=1 DISABLE_IA32_LINUX=1 DISABLE_ST40_OS21=1 DISABLE_ST220_OS21=1 DISABLE_ST231_OS21=1
%endif

%install
rm -rf %{buildroot}

%ifarch noarch
install -d -m 755 %{buildroot}%{_stm_sources_dir}/multicom/multicom-%{version}-%{release}
tar chf - . | tar xf - -C %{buildroot}%{_stm_sources_dir}/multicom/multicom-%{version}-%{release}
%else

# build the directory structures
mkdir -p %{buildroot}%{_stm_cross_target_dir}%{_stm_target_lib_dir}
mkdir -p %{buildroot}%{_stm_cross_target_dir}%{_stm_target_include_dir}

# copy out the shared libraries (and any static libraries)
cp lib/linux/st40/lib* %{buildroot}%{_stm_cross_target_dir}%{_stm_target_lib_dir}

# copy out the header files
cp include/* %{buildroot}%{_stm_cross_target_dir}%{_stm_target_include_dir}

%endif

%clean
rm -rf %{buildroot}

%ifarch noarch

%files -n %{_pkgname}
%defattr(-,root,root)
%{_stm_sources_dir}/multicom/multicom-%{version}-%{release}

%post -n %{_pkgname}
# Since it is not an error to parallel install multicom, we don't want the
# link to the 'latest' to be part of the spec file.
rm -f %{_stm_sources_dir}/multicom/multicom
ln -s multicom-%{version}-%{release} %{_stm_sources_dir}/multicom/multicom

%preun -n %{_pkgname}
if [ x`readlink %{_stm_sources_dir}/multicom/multicom` == xmulticom-%{version}-%{release} ] ; then
	rm -f %{_stm_sources_dir}/multicom/multicom
fi

%else

%files -n %{_pkgname}
%defattr(-,root,root)
%{_stm_cross_target_dir}%{_stm_target_lib_dir}/lib*.so
%doc docs/license.pdf

%files -n %{_pkgname}-devel
%defattr(-,root,root)
%{_stm_cross_target_dir}%{_stm_target_include_dir}/*.h
#%%{_stm_cross_target_dir}%{_stm_target_lib_dir}/lib*.a
%doc docs/license.pdf

%endif

%changelog
* Thu Aug 13 2009 Gavin Newman <gavin.newman@st.com> - 3.2.4rc3-1
- Mem Alloc Fix (bug 6998)

* Mon Aug 03 2009 Chris Tomlinson <christopher tomlinson@st.com> - 3.2.4rc2-3
- Fix issue with rpm build not working on certain systems
  (Explicitly set the library search path in host library link.)

* Wed Jul 29 2009 <daniel.thomspon@st.com> - 3.2.4rc2-2
- Fix build system flaw that prevented DirectFB image provides from
  working (bug 6835).

* Wed Jul 22 2009 <daniel.thompson@st.com> - 3.2.4rc2-1
- Updated to latest version of multicom (for multi-hosting feature)

* Thu Jul 24 2008 <peter.bennett@st.com> - 3.2.2-3
- Upgraded to latest version of multicom (patch2)

* Thu Jul 03 2008 Gavin Newman <gavin.newman@st.com> - 3.2.1-3
- added 4293_bpa2.patch

* Mon Apr 07 2008 Chris Tomlinson <christopher tomlinson@st.com> - 3.2.1-2
- Upgrade to latest upstream sources (bug fixed initial release)

* Thu Apr 03 2008 Chris Tomlinson <christopher tomlinson@st.com> - 3.2.1-1
- Upgrade to latest upstream sources (initial release)

* Thu Mar 13 2008 Chris Tomlinson <christopher tomlinson@st.com> - 3.2.1_b4-1
- Upgrade to latest upstream sources.

* Fri Feb 08 2008 Chris Tomlinson <christopher tomlinson@st.com> - 3.2.1_b3-1
- Upgrade to latest upstream sources.
- Build Multicom SH4 module in GPL mode

* Thu Jan 17 2008 Daniel Thompson <daniel.thompson@st.com> - 3.2.1_b2-1
- Upgrade to latest upstream sources.

* Wed Jan 09 2008 Daniel Thompson <daniel.thompson@st.com> - 3.2.1_b1-1
- Upgrade to latest upstream sources (this will break wire compatibility).

* Wed Sep 26 2007 Daniel Thompson <daniel.thompson@st.com> - 3.1.2-1
- Upgrade to latest upstream sources.

* Tue Sep 25 2007 Daniel Thompson <daniel.thompson@st.com> - 3.1.1-9
- Fixed a bug in the support for large warp ranges. This fixes a
  DivX playback regression on STx710x.

* Tue Sep 11 2007 Daniel Thompson <daniel.thompson@st.com> - 3.1.1-8
- Include patch to support warp ranges larger than 256M (for STx7200).

* Fri Aug 31 2007 Daniel Thompson <daniel.thompson@st.com> - 3.1.1-7
- Reinstate the lib directory to allow firmwares to be built against the
  installed packages.

* Mon Jun 4 2007 Peter Bennett <peter.bennett@st.com> - 3.1.1-6
- Updated to new build system

* Thu May 10 2007 Daniel Thompson <daniel.thompson@st.com> - 3.1.1-5
- Explicitly select the ST200 toolset (rather than rely on the caller's PATH).
- Include patch to support recent (source incompatible) versions of OS21.
- Packaged the multicom shared libary properly.

* Mon Apr 02 2007 Daniel Thompson <daniel.thompson@st.com> - 3.1.1-4
- Included enhancement INSbl26934 (warning free build).

* Wed Dec 20 2006 Brendan O'Connor <brendan.oconnor@st.com> - 3.1.1-3
- Disable ST40_OS21.

* Tue Nov 21 2006 Brendan O'Connor <brendan.oconnor@st.com>
- Convert to STLinux-2.2 macro names.

* Mon Nov 13 2006 Daniel Thompson <daniel.thompson@st.com> - 3.1.1-3
- Included enhancement INSbl26321 (compatibility with STLinux-2.2).

* Tue Oct 24 2006 Daniel Thompson <daniel.thompson@st.com> - 3.1.1-2
- Included fix for INSbl26526 (memory leak in MME_FreeDataBuffer;
  Linux user mode only).
- Included enhancement INSbl26569 (provide a dynamically linked
  libmme_host for Linux user mode).
- Corrected the file permissions required for the test suite to
  operate.
- Included an unversioned symlink in the source directory.

* Fri Aug 18 2006 Daniel Thompson <daniel.thompson@st.com> - 3.1.1-1
- Update to multicom-3.1.1.
- Tagged the installation directory with the RPM release number.
- Included fix for INSbl25867 (NULL deref on thread create with 
  CONFIG_PREEMPT).

* Mon Apr 3 2006 Daniel Thompson <daniel.thompson@st.com> - 3.0.4-7
- Removed target libraries where the pre-compiled binary does not
  match the supplied source.

* Mon Mar 20 2006 Daniel Thompson <daniel.thompson@st.com> - 3.0.4-6
- Back port fix for INSbl25570 (memory leak in MME_GetTransformerCapability)

* Mon Mar 6 2006 Daniel Thompson <daniel.thompson@st.com> - 3.0.4-5
- Back port fix for INSbl25507 (incorrect thread initialization).

* Fri Feb 10 2006 Daniel Thompson <daniel.thompson@st.com> - 3.0.4-4
- Back port a significant portion of the R3.1.1 patches to R3.0.4.
- Rebuild the libraries for the embedded toolsets.

* Tue Jul  5 2005 Daniel Thompson <daniel.thompson@st.com>
- First version
