/*
 * Copyright (C) 2009 STMicroelectronics Limited
 *
 * May be copied or modified under the terms of the GNU General Public
 * License.  See linux/COPYING for more information.
 *
 * Code to handle the clockgen hardware on the STx7108.
 */

#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/stm/clk.h>



/* SH4 generic clocks ----------------------------------------------------- */

static struct clk stx7108_generic_module_clk = {
	.name		= "module_clk",
	.flags		= CLK_ALWAYS_ENABLED,
	.rate		= 100000000,
};

static struct clk stx7108_generic_comms_clk = {
	.name		= "comms_clk",
	.flags		= CLK_ALWAYS_ENABLED,
	.rate		= 100000000,
};



/* ------------------------------------------------------------------------ */

int __init clk_init(void)
{
	int err;

	/* Generic SH-4 clocks */

	err = clk_register(&stx7108_generic_module_clk);
	if (err != 0)
		goto error;

	err = clk_register(&stx7108_generic_comms_clk);

error:
	return err;
}

