/*
 * Direct UBI block device access
 *
 * Author: dmitry pervushin <dimka@embeddedalley.com>
 *
 * Copyright 2008 Freescale Semiconductor, Inc. All Rights Reserved.
 * Copyright 2008 Embedded Alley Solutions, Inc. All Rights Reserved.
 * Copyright 2010 Wyplay SAS. All Rights Reserved.
 *
 * The code contained herein is licensed under the GNU General Public
 * License. You may obtain a copy of the GNU General Public License
 * Version 2 or later at the following locations:
 *
 * http://www.opensource.org/licenses/gpl-license.html
 * http://www.gnu.org/copyleft/gpl.html
 *
 * Based on mtdblock by:
 * (C) 2000-2003 Nicolas Pitre <nico@cam.org>
 * (C) 1999-2003 David Woodhouse <dwmw2@infradead.org>
 */

#ifndef __UBIBLK_RO_USER_H__
#define __UBIBLK_RO_USER_H__

struct ubiblk_req {
	uint32_t ubi_dev_id;
	uint32_t ubi_vol_id;
};

#define UBIBLK_MAGIC	'U'

#define UBIBLOCK_ADDVOL	_IOW(UBIBLK_MAGIC, 0x01, struct ubiblk_req *)
#define UBIBLOCK_RMVOL	_IOW(UBIBLK_MAGIC, 0x02, struct ubiblk_req *)

#endif	/* __UBIBLK_RO_USER_H__ */

